/**************************************************************************
 *
 *   Copyright (c) 2003 Openwave Systems Inc.  All rights reserved.
 *
 *   Openwave Systems Inc. grants you the right to use the Openwave Location
 *   Studio SDK software and its related documentation only according
 *   to Openwave's Location Studio SDK End User Software License Agreement.
 *
 *   Openwave and the Openwave logo are registered trademarks of Openwave
 *   Systems Inc. All other trademarks and registered trademarks are the
 *   properties of their respective owners.
 *
 **************************************************************************/

import electric.registry.Registry;
import electric.registry.RegistryException;

import java.io.FileInputStream;
import java.util.Properties;
import java.net.*;
import com.signalsoftcorp.lst.client.SubscriberId;
import com.signalsoftcorp.lst.client.WLILocation;
import com.signalsoftcorp.lst.client.WLP10LocationRequest;
import com.signalsoftcorp.lst.client.WLP10LocationResponse;
import com.signalsoftcorp.lst.client.WLP10Position;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
public class restaurant extends HttpServlet {

  //Initializes the servlet.
    
  public void init(ServletConfig config) throws ServletException{
   
        super.init(config);
        
  }
    
  //Destroys the servlet.
     
  public void destroy(){
    
        
  }


public void doGet(HttpServletRequest request, 
                    HttpServletResponse response)
            throws IOException, ServletException {
    response.setContentType("text/html");
    
    //disable cache
    response.setHeader("Cache-Control", "no-cache"); 
    PrintWriter out = response.getWriter();
    String x = null;
    String y = null;
    String address= null;
     try 
     {
        /* Get the variables of this interface from the example_variables.properties file.
         If you Tomcat cannot find "example_variables.properties", please use the absolute path.
         For PC, use "c:\\[tomcat-home]\\webapps\\location\\WEB-INF\\classes\\example_variables.properties"
         For UNIX, use "/[tomcat-home]/webapps/location/WEB-INF/classes/example_variables.properties"
        */
        String property_filename = "example_variables.properties";
        FileInputStream property_file = new FileInputStream( property_filename );
        Properties variables = new Properties();
        variables.load( property_file );
        
	  //use electric to bind to the LSt web service  
        WLILocation lif = (WLILocation)Registry.bind( variables.getProperty("LStURL"), WLILocation.class );

        // build the request arguments
        SubscriberId[] subscriberArray = { 
           new SubscriberId(variables.getProperty("subscriber0Type"), variables.getProperty("subscriber0Id")),
           new SubscriberId(variables.getProperty("subscriber1Type"), variables.getProperty("subscriber1Id")) };

        Integer timeOut = new Integer( variables.getProperty("timeOut") );
        Integer maxLocAge = new Integer( variables.getProperty("maxLocAge") );

        // example of WLP10LocationRequest constructor
        WLP10LocationRequest requestL = new WLP10LocationRequest(
           subscriberArray,
           timeOut.intValue(),
           maxLocAge.intValue());
        
        //make the request by executing the getLocation() method with a WLP10LocationRequest argument
        WLP10LocationResponse responseL = lif.getLocation(
           variables.getProperty("clientId"),
           variables.getProperty("password"),
           requestL );
        
        //retrieve the latitude and longitude
	  WLP10Position[] positions = responseL.getWLP10Position();
        if ( positions.length > 0 )
           {
               
             x = positions[0].getLatitude();
             y = positions[0].getLongitude();
           }
        }
     
     catch ( RegistryException re )
     {}
     catch ( Exception e )
     {
 	System.out.println(e.toString());
     }
     
     address = getAddress(x, y);
     
     //output the location information and a list of restaurants in XHTML deck  
      
     out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
     out.println("<!DOCTYPE html PUBLIC \"-//WAPFORUM//DTD XHTML Mobile 1.0//EN\""+
                   "\"http://www.wapforum.org/DTD/xhtml-mobile10.dtd\">");
     out.println("<html xmlns=\"http://www.w3.org/1999/xhtml\""+
            "xml:lang=\"en\">");
     out.println("<head>"+"<title>City Guide</title>"+
                  "<link href=\"/location/restaurant/style.css\" rel=\"stylesheet\" type=\"text/css\"/>");
     out.println("</head>"+"<body>"+"<p>"+
                 "<img src=\"/location/restaurant/meal.gif\" alt=\"\"/><b> Restaurants</b><br/>"+
                 "Your current location is "+address + ". <br/> Choose restaurants within 1 mile:</p>");
     out.println("<table>"+
                  "<tr class=\"blue\">"+
			"<td><p class=\"nowrap\">1 <a accesskey=\"1\" href=\"/location/servlet/find?mile=1&type=American\">American (2 Restaurants)</a></p></td>"+
			"</tr><tr><td><p class=\"nowrap\">2 "+
    			 "<a accesskey=\"2\" class=\"bluetext\" href=\"/location/servlet/find?mile=1&type=Chinese\">Chinese (2 Restaurants) </a></p></td>"+
			"</tr><tr class=\"blue\"><td><p class=\"nowrap\">3 "+
			"<a accesskey=\"3\" href=\"/location/servlet/find?mile=1&type=French\">French (2 Restaurants)</a></p></td></tr>"+
 			"<tr><td><p class=\"nowrap\">4 "+
			"<a accesskey=\"4\" class=\"bluetext\" href=\"/location/servlet/find?mile=1&type=Italian\">Italian (2 Restaurants)</a></p></td></tr>"+
			"<tr class=\"blue\"><td><p class=\"nowrap\">5 "+
			"<a accesskey=\"5\" href=\"/location/servlet/find?mile=1&type=Japanese\">Japanese (2 Restaurants)</a></p></td></tr>"+
			"<tr><td><p class=\"nowrap\">6 "+
			"<a accesskey=\"6\" class=\"bluetext\" href=\"/location/servlet/find?mile=1&type=Mexican\">Mexican (2 Restaurants)</a></p></td></tr>"+
			"</table><p><a class=\"darkblue\" href=\"/location/restaurant/more.html\">More</a>"+"<br/>"+
			"<a class=\"darkblue\" href=\"/location/servlet/change?type=restaurant&address="+URLEncoder.encode(address)+"\">Change Location</a><br/>"+
			"<a class=\"darkblue\" href=\"/location/index.html\">City Guide</a>"+
			"</p></body></html>");


  }
  
  /* mockup for a method that looks into the location database for physical address 
    based on x and y.  In this application it returns a dummy address.*/
  public String getAddress(String x, String y){
   String location = null;
   if((x.equals("40 07 24.441N"))&&(y.equals("105 07 24.441W")))
     location = "Market Street, San Francisco";
   return location;
 }
    
}

